"The most important development in the world of literature after Gutenberg is the electronic book or ebook"
- Sirigindi Subba Rao


"When visiting an e-book, [students] did not want to read it entirely; rather, they turn to the table of contents and determine which chapters seem relevant."
- Understøtter valget med å lage en TOC som er lett tilgjengelig


Convenience
Kan kopiere direkte til Word-documents

Få annoterer digitalt innhold, selv om det er mulig, men noen sier de vil gjøre det "if they got used to it"



Der er en forskjell på ebøker og artikler - mest på lengde

"However, as the sessions progressed, it became apparent that they do distinguish between e-journal articles and e-books. They express a preference for e-journal articles given their brevity in comparison to an e-book."



Forskjeller i hvordan folk leser på papir sammenlignet med ebøker
"the participants do not view the e-book as similar to a print book—something to read from cover to cover. As one student admitted, “I lack the patience to read e-books page by page. I like to scan for key concepts and skip around the text.” Another student states that if she cannot find what she wants by scanning e-text, she abandons that source and seeks another. She does not search within the contents (e.g., by word), even when the observers point out this option."










## Electronic books: their integration into library and information centers

Siriginidi Subba Rao (2005)

Eboks are the third wave of electronic publishing

> Rao (2001) has provided a more comprehensive definition for the e-book as a text in digital form or a book converted into digital form or digital reading material or book in a computer file format or electronic file of words, images with unique identifiers, metadata to be displayed on computer screen or read on a computer through a network or view on a desktop/notebook/dedicated portable device or read on all types of computers or formatted for display on e-book readers."



### Advantages (MERK: for LIC, ikke sluttbruker)
* Savings
* Delivery to user
* Expanding collections
* Staff's efficiency

### Disadvantages
* Technical and management problems
* Developing model
* Resistance to change


The article lists a myriad of different devices capable of rendering ebooks, none interoperable. What is worse, none are existing today, which further accentuates the problem.











## The Imposition and Superimposition of Digital Reading Technology: The Academic Potential of E-readers
Alexander Thayer, Charlotte P. Lee, Linda H. Hwang, Heidi Sales, Pausali Sen, and Ninad Dalal (2011)

http://dl.acm.org/citation.cfm?id=1979375

> Translating certain affordances from paper to e-reader (such as fanning and flipping pages) is potentially more confusing than helpful to users.

- En grunn til å se forbi metaforene som benyttes. Ikke emulere, men heller ta det beste fra affordancene, gjøre de til ens egen, skape nytt

> Waller describes the importance of building a cognitive map of content during active reading, a practice where “headings, illustrations and other features act as landmarks”

Pugh beskriver 5 taktikker

* Scanning
* Seach reading
* Skimming
* Receptive reading
* Responsive reading


> [...] academic work involves a variety of navigation techniques, such as cross- referencing information within a text and across multiple texts. Studies of e-readers in academic environments indicate they are imperfect devices for these activities.


Alt i alt er det synlig at brukervennlig navigasjon er alfa og omega! Er og en del funksjonalitet som må være på plass! Highlighting tas igjen og igjen fram som eksempel. Mulig å gjøre, men vanskelig. Mulighet for å raskt flippe gjennom sider er og viktig.

> Producing markup is a defining aspect of **responsive reading**, or using a text to develop ideas or modify existing knowledge.

> [...] although the Kindle DX was poor for responsive reading, which typically involves marking up, they found that it was still acceptable for receptive reading situations.

> When they have no cognitive maps on which to rely, the process of locating information takes longer, they have less mental energy for other tasks, and their ability to maintain their desired levels of productivity suffers


> Therefore, our research confirmed the importance of supporting responsive reading techniques, as well as the need to support students’ generation of new texts based in part on the knowledge they gain when reading responsively.

> Thus, in order to effectively support responsive reading, it is necessary to support seamless switching between different reading techniques.




## 

http://www.sigchi.org/chi97/proceedings/paper/koh.htm

