// execute this as soon as possible



function showDialog(text) {
    // todo
}



$(function(){

     // Adds an id to all p elements
    (function(){
        var pElements = document.getElementsByTagName('p');
        for(var i=0; i<pElements.length; i++){
            pElements[i].id = 'pid' + i;
        }

        h = window.location.hash;

        window.setTimeout(function(){
            window.location.hash = h;
        }, 0);
    })();


    _.templateSettings = {
     evaluate : /\{\[([\s\S]+?)\]\}/g,
     interpolate : /\{\{([\s\S]+?)\}\}/g
    };



    (function(){
        var wn = window.location;
        if(wn.pathname!='/' && wn.pathname !='/kompendium/') {
            if(!window.localStorage.position || JSON.parse(window.localStorage.position).href != wn.href) {

                window.localStorage.setItem('position', JSON.stringify(
                    {
                        "href": wn.href,
                        "title": document.title,
                        "pathname": wn.pathname,
                        "hash": wn.hash,
                        "host": wn.host,
                        "hostname": wn.hostname,
                        "href": wn.href,
                        "pathname": wn.pathname,
                        "port": wn.port,
                        "protocol": wn.protocol,
                        "search": wn.search
                    })
                );
                console.log("saved position");
            }
        }
        if(window.localStorage.getItem('position')) {
            (function(){
                var position = JSON.parse(window.localStorage.position);

                if(position.href != wn.href) {
                    var template = _.template($('#template-alertbox-persistent').html());

                    $('body').append(template({
                        "body": "Trykk her for fortsette lesingen fra forrige gang.",
                        "href": position.href,
                        "title": position.title
                    }));

                    $('.alert-box .close-button').click(function(){
                        $(this.parentElement).remove();
                    });
                }


                // if (window.location.href != position.href){
                //     window.location.href = position.href;
                // }
            })();
        }
    })();


    //initNavButtons();

    // Initializes the navigation buttons
    (function() {
        var mainWrapper = document.getElementById('main-wrapper');
        var contentWrapper = document.getElementById('content-wrapper');

        if(contentWrapper.pageCount) {
            $('#footer-main').css('visibility', 'visible').css('height', 'auto');
        }
        else {
            $('.content').css('height', '100%');
            $('.main').css('height', '100%');
            $('.body').css('height', '85%');

        }

        document.getElementById('widget_pager').getElementsByClassName('page_current')[0].innerHTML = contentWrapper.currentPage + 1;
        document.getElementById('widget_pager').getElementsByClassName('page_total')[0].innerHTML = contentWrapper.pageCount;
    })();

    
    //initSlideshowButtons();
    //initMetaData();


    // (function(){
    //     // unfortunately, this needs to be accomplished in a hacky manner

    //     var footer = document.getElementById("main-footer");
    //     var hammer = new Hammer(footer);

        
    //     var div = document.createElement('div');
    //     div.style = 'background: transparent; position: absolute; width: 100%; height: 40px; top: -40px; left: 0; display: block; pointer: zoom-in;'
    //     hammer.ontap = function(ev) {
    //         // Registers a tap and expands the element to allow a drag motion
    //         div.style = 'display: block;';
    //         footer.appendChild(div);
    //     };

    //     // Registers the drag motion
    //     hammer.ondrag = function(ev) {
    //         console.log('rawr');
    //         div.style = 'display: none;'
    //         $('#sidebar').addClass('visible');
    //     };
    // })();


    // inits keylisteners
    (function(){
        $(document).on('keyup', function(e){
            var sideBarIsOpen = function(){return $('#sidebar').hasClass('visible')}();

            switch(e.keyCode){
                // case 27: // esc
                //     $('#sidebar').toggleClass('visible');
                //     break;
                case 37: // left
                    e.preventDefault();
                    return false;
                    // if(sideBarIsOpen) {
                    //     return false;
                    // }
                    break;
                case 39: // right
                    e.preventDefault();
                    return false;
                    // if(sideBarIsOpen) {
                    //     return false;
                    // }
                    break;
                case 38: // up
                    break;
                case 40: //down
                    break;
            }
        });

        $(document).on('keydown', function(e){
            switch(e.keyCode){
                case 32: // space
                    e.preventDefault();
                    if(e.shiftKey){
                        document.getElementById('content-wrapper').currentPage--;
                    }
                    else {
                        document.getElementById('content-wrapper').currentPage++;
                    }
                    break;
                case 37: // left
                    e.preventDefault();
                    document.getElementById('content-wrapper').currentPage--;
                    break;
                case 39: // right
                    e.preventDefault();
                    document.getElementById('content-wrapper').currentPage++;
                    break;
            }


        })
    })();


    // Inits highlighter
    (function(){

        if(!window.metadata) {
            return;
        }

        var highlights;
        if(window.localStorage.highlights) {
            highlights = JSON.parse(window.localStorage.highlights);
        }
        else {
            highlights = {};

            for (var i = 0; i < 16; i++) {
                highlights['chapter' + i] = [];
            }

            window.localStorage.setItem('highlights', JSON.stringify(highlights));
        }

        var chapter;

        chapter = highlights['chapter' + window.metadata.chapter];

        var storeRange = function(range, body){
            var highlight = {};
            highlight.startElement = range.startContainer.parentNode.id;
            highlight.startOffset = range.startOffset;

            highlight.endElement = range.endContainer.parentNode.id;
            highlight.endOffset = range.endOffset;

            highlight.body = body;
            highlight.chapter = window.metadata.chapter;
            highlight.href = window.location.pathname;


            chapter.push(highlight);

            window.localStorage.setItem('highlights', JSON.stringify(highlights));


            // dataformat

            // highlights: {
            //     chapter1: [
            //         data
            //     ]
            // }
        }
        rangy.init();

        $('#highlighter').click(function(){
            window.highlightMode = !window.highlightMode;
            $(this).toggleClass('active');
        });


        // $(document).on('mousedown', function(ev){
        //     var startElement =  ev.srcElement;
        var highlightApplier = rangy.createCssClassApplier("highlight ", true);
            $(document).on('mouseup', function(e){
                // if(!highlightMode) {
                //     return;
                // }

                var selection = window.getSelection();
                var text = selection.toString();
                console.log(text);
                if(selection.anchorOffset!=selection.focusOffset) {


                    var wrapper = document.createElement('div');
                    var button = document.createElement('div');

                    $(wrapper)
                        .css('position', 'absolute')
                        .css('top', e.pageY - 40)
                        .css('left', e.pageX)
                        .css('color', 'white')
                        .css('border-radius', '5px')
                        .css('background', 'rgb(55, 58, 58)')
                        .css('box-shadow', '1px -1px 0 #000, 1px 1px 0 #000, -1px 1px 0 #000, -1px -1px 0 #000')
                        .css('border-right', '1px solid rgb(34,34,34)')
                        .css('border-bottom', '1px solid rgb(34,34,34)');
                    button.innerHTML = 'Highlight';
                    $(button)
                        .css('padding', '.2em .5em')
                        .css('cursor', 'pointer');

                    wrapper.appendChild(button);


                    $(document).click(function(){
                        $(button).remove();
                    })

                    var ranges = highlightApplier.hackThing();
                    
                    $(button).click(function(){
                        console.log(ranges);


                        for(var j=0; j<ranges[0].length; j++) {
                            storeRange(ranges[0][j].nativeRange, text);
                        }

                        highlightApplier.applyToSelection(ranges[0], ranges[1], ranges[2]);
                        // var range = ranges[0].nativeRange;
                        // console.log(range);

                        window.getSelection().removeAllRanges();
                    });
                    document.body.appendChild(wrapper);



                    
                }
            });
        // });

        

        // register mouse event listener
        // $(document).on('mouseup', function(e){
        //     var selection = window.getSelection();
        //     if(selection.anchorOffset!=selection.focusOffset) {
        //         var range = selection.getRangeAt(0);
        //         var h = document.createElement('span');
        //         h.className = 'highlight';
        //         h.id = 'highlight' + highlights['chapter8'].length;
        //         storeRange(range);
        //         range.surroundContents(h);
        //     }
        // });


        // // highlights saved passages 

        var ranges;
        if(window.localStorage.highlights) {
            if(!window.metadata || window.metadata == undefined) {
                return;
            }
            ranges = JSON.parse(window.localStorage.highlights);


            if(ranges['chapter' + window.metadata.chapter]) {
                ranges['chapter' + window.metadata.chapter].forEach(function(hl, i){
                    

                    try {
                        var highlightApplier = rangy.createCssClassApplier("highlight ", true);
                        var range = rangy.createRange();

                        range.setStart(document.getElementById(hl.startElement).firstChild, hl.startOffset);
                        range.setEnd(document.getElementById(hl.endElement).firstChild, hl.endOffset);
                        
                        highlightApplier.applyToRange(range);
                    }
                    catch(error) {
                        console.log('error');
                    }

                });
            }
        }


    })();

   
    // Inits the sidebar (do this with a templating engine?)
    (function(){
        var div = document.createElement('div');
        div.className = 'testchapter';
        div.offsetTop = 0;
        var nav = document.createElement('nav');
        var ul = document.createElement('ul');
        div.appendChild(nav);
        nav.appendChild(ul);
        document.getElementById('chapter-loader-scroller').appendChild(div);

        // First add the index page
        ul.appendChild(createChapterEntry({
            title: 'Index',
            description: 'Table of contents',
            url: '/'
        }));

        // then the rest of the chapters
        structure.structure.forEach(function(element){
            ul.appendChild(createChapterEntry(element));
        });

        // after it is done loading, do a quick little jiggy
        window.setTimeout(function(){
            $('#open-sidebar-button').click();
            window.setTimeout(function(){
                $('#open-sidebar-button').click();
                window.setTimeout(function(){
                    $('#open-sidebar-button').click()
                    window.setTimeout(function(){
                        $('#open-sidebar-button').click()
                    }, 50);
                }, 200);
            }, 170);
        }, 200);

    })();

    
    // Quick hack to remove all empty p-nodes
    $("p").filter(function(){
        return $.trim(this.innerHTML) === ""
    }).remove();

    // Pretty loader
    (function(){
        $('#loader-wrapper').css('opacity', 0);
        window.setTimeout(function(){
            $('#loader-wrapper').remove();
        }, 300);
    })();
});


window.highlightMode = false;


function createChapterEntry(element) {
    var article = document.createElement('article');
    var li = document.createElement('li');
    var a = document.createElement('a');
    a.appendChild(article);


    if(!element.isLastChild) {
        var extra = document.createElement('a');
        // extra.style = 'position: absolute; top: 0; right: 0; width: 25px; background: red; height: 100%; display: table-cell; vertical-align: middle;';
        extra.innerHTML = '<div class="purty"></div>';
        extra.className = 'chapter-loader-next';
        li.appendChild(extra);

        $(extra).click(function(){
            $(article).addClass('loading');

            //TODO!
            $.get(this.nextElementSibling.href, function(data){
                var h2elements = $(data).find('h2');
                var content = [];
                debugger;
                _.each(h2elements, function(el){
                    content.push({
                        "author" : element.author,
                        "chapter" : element.chapter,
                        "title" : el.innerHTML,
                        "url" : element.url + '#' + formatName(el.innerHTML)
                    });
                });


                console.log(h2elements);
                console.log(content);

                acc.loadChapter(content, element.title);

                $(article).removeClass('loading');
            });


            // element
            // author "Terje Rydland"
            // chapter "2"
            // description "Dette er et kapittel"
            // title "Former for IKT i skolen"
            // url "/kompendium/former-for-ikt-i-skolen.html"

        });
    }


    var title = document.createElement('p');
    var description = document.createElement('p');
    title.className = 'title';
    description.className = 'description';

    if(element.description) {
        description.innerHTML = element.description;
    }
    else {
        description.innerHTML = ' ';
    }

    article.appendChild(title);
    article.appendChild(description);

    title.innerHTML = element.title;

    a.href = element.url;

    if(element.content) {
        a.className = 'has-contents';
        $(a).click(function(e){
            e.preventDefault();
            $(article).addClass('loading');

            // $.get('https://api.github.com/users/tkbremnes/orgs', function(response){
            //     console.log(response);
            //     acc.loadChapter(response);
            // }).success(function(){
            //     $(article).removeClass('loading');
            // });
            acc.loadChapter(element.content);

            $(article).removeClass('loading');
            return false;
        });

        var l = document.createElement('img');
        l.src = '/loading.gif';
        l.className = 'loading-gif';
        article.appendChild(l);


    }
    else {
        a.className = 'lone-file';
        $(a).click(function(e){
            e.preventDefault();
            window.location.href = this.href;
        });
    }
    li.appendChild(a);
    return li;
}





$('img').click(function(){
    console.log(this);
    var lightbox = document.createElement('div');
    lightbox.className = 'lightbox';

    var content = document.createElement('div');
    content.className = 'content';

    // var img = document.createElement('img');
    // img.src = this.src;
    var c = $(this).clone();
    content.appendChild(c[0]);

    lightbox.appendChild(content);

    var closeButton = document.createElement('a');
    closeButton.className = 'close-button';

    $(closeButton).click(function(){
        $(this.parentElement).remove();
    });

    lightbox.appendChild(closeButton);



    document.body.appendChild(lightbox);
});

function imgLightbox() {
}





// This can be done more efficient!
var scrollInterval;
function updateReadingProgress(destination, duration){

    // ANIMATION REMOVED!

    // duration = duration || 500;
    
    // if(scrollInterval) {
    //     window.clearInterval(scrollInterval);
    // }
    // meter = $('widget_pager').find('meter');
    // var intervals = 10; //calculate this!
    // var increment;
    // if(document.getElementById('widget_pager').getElementsByTagName('meter')[0].value<destination) {
    //     increment = 1;
    // }
    // else {
    //     increment = -1;
    // }

    // scrollInterval = window.setInterval(function(){
    //     if(document.getElementById('widget_pager').getElementsByTagName('meter')[0].value!=destination) {
    //         document.getElementById('widget_pager').getElementsByTagName('meter')[0].value += increment;
    //     }
    //     else {
    //         window.clearInterval(scrollInterval);
    //     }
    // }, intervals);
    document.getElementById('widget_pager').getElementsByTagName('meter')[0].value = destination;

}


// $('#content-wrapper').click(function(e){
//     if(e.srcElement.tagName!=='A' && e.srcElement.tagName!='IMG'){
//         $('#sidebar').toggleClass('visible');
//     }
// });


document.getElementById('content-wrapper').onpagechange = function(e){
    if(e.srcElement.id=='content-wrapper') {
        document.getElementById('widget_pager').getElementsByClassName('page_current')[0].innerHTML = e.currentPage + 1;
        document.getElementById('widget_pager').getElementsByClassName('page_total')[0].innerHTML = e.pageCount;


    }
    else {
        e.srcElement.parentElement.getElementsByClassName('pages')[0].getElementsByClassName('page_current')[0].innerHTML = e.currentPage + 1;
        e.srcElement.parentElement.getElementsByClassName('pages')[0].getElementsByClassName('page_total')[0].innerHTML = e.pageCount;
        
    }
    var target = Math.ceil(((e.currentPage)/(e.pageCount-1))*100);
    updateReadingProgress(target, 300);
    //document.getElementById('widget_pager').getElementsByTagName('meter')[0].value = target;

    $('#sidebar').removeClass('visible');
};



function nextPage() {
    document.getElementById('content-wrapper').currentPage++;
}

function previousPage() {
    document.getElementById('content-wrapper').currentPage--;
}

function initSlideshowButtons() {
    $('.slideshow_next').on('click', function() {
        this.parentElement.parentElement.getElementsByClassName('content')[0].currentPage++;
    });

    $('.slideshow_previous').on('click', function() {
        this.parentElement.parentElement.getElementsByClassName('content')[0].currentPage--;
    })
}


function getBibItem(bibId, destination) {
    bibJSON.records.forEach(function(item){
        if(item.id==bibId){
            var table = document.createElement('table');
            var th = document.createElement('th');
            th.innerHTML = item.title;
            th.colSpan = '2';
            table.appendChild(th);


            table.appendChild(createTableRow('Author(s)', item.author));
            table.appendChild(createTableRow('Journal', item.journal));
            table.appendChild(createTableRow('Number', item.number));
            table.appendChild(createTableRow('Volume', item.volume));
            table.appendChild(createTableRow('Month', item.month));
            
            destination.appendChild(table);
        }
    });
}


function createTableRow(title, content) {
    var titleTd = document.createElement('td');
    var contentTd = document.createElement('td');

    titleTd.innerHTML = title;

    if(content instanceof Array){
        var ul = document.createElement('ul');
        contentTd.appendChild(ul);
        content.forEach(function(item){
            var li = document.createElement('li');
            if(item instanceof Object){
                li.innerHTML = item.name;
            }
            else {
                li.innerHTML = item;
            }
            ul.appendChild(li);
        });
    }
    else {
        if(content instanceof Object) {
            contentTd.innerHTML = content.name;
        }
        else {
            contentTd.innerHTML = content;
        }
    }
    var row = document.createElement('tr');
    row.appendChild(titleTd);
    row.appendChild(contentTd);

    return row;
}


function initMetaData() {
    // source: http://stackoverflow.com/questions/8396541/javascript-to-get-elements-by-its-attribute
    var arr_elms = [];
    arr_elms = document.body.getElementsByTagName("*");
    var elms_len = arr_elms.length;

    for (var i = 0; i < elms_len; i++) {
      if(arr_elms[i].getAttribute("data-attribute-cite") != null){
          var div = document.createElement('div');
          div.className = 'article-metadata';
          getBibItem(arr_elms[i].getAttribute("data-attribute-cite"), div);
          document.getElementsByClassName('body')[0].appendChild(div);
       }
    }
}

function capitaliseFirstLetter(string)
{
    return string.charAt(0).toUpperCase() + string.slice(1);
}






function toggleSettingsMenu() {
    if(document.getElementById('settings-menu')){
        $('#settings-menu').remove();
    }
    else {
        var wrapper = document.createElement('div');
        wrapper.className = 'menu settings';
        wrapper.id = 'settings-menu';
        wrapper.innerHTML = 'Settings and stuff';
        document.body.appendChild(wrapper);
    }
}


// function initModelNotUsed() {
//     window.BibItem = Backbone.Model.extend({
        
//     });

//     window.BibView = Backbone.View.extend({
//         tagname: 'li',
//         classname: 'bibitem',
//         render: function() {
//             $(this.el).html(this.template(this.model.toJSON()));
//             return this;
//         }
//     })

//     window.BibCollection = Backbone.Collection.extend({
//         model: BibItem
//     });

//     window.collection = new BibCollection();
//     bibJSON.records.forEach(function(record){
//         var item = new BibItem();

//         for(key in record){
//             item[key] = record[key];
//         }

//         collection.add(item);
        
//         var view = new BibView({model: item});
//     });



//     window.AppView = Backbone.View.extend({
//         initialize: function{
//             collection.fetch();
//         }

//     })

//     var App = new AppView;

// }


$('#open-sidebar-button').click(function(event){
    event.preventDefault();
    $('#sidebar').toggleClass('visible');
    $('#open-sidebar-button').toggleClass('hack');
    return false;
});


$('#close-sidebar-button').click(function(event){
    event.preventDefault();
    $('#sidebar').toggleClass('visible');
    $('#open-sidebar-button').toggleClass('hack');
    return false;
});

$('#testlink').click(function(){
    asideLoadLocation(this.attributes['data-href'].value);
});

function asideLoadLocation(loc) {

}

function asideChapterContainer() {
    this.position = 0;
    this.increments = 300; // todo: do this programatically
    this.active = document.getElementById('chapter-loader-scroller');

    this.scrollLeft = function() {
        this.position -= this.increments;
        $('#sidebar .controls a.prev').css('display', 'block');
        
        $('#chapter-loader-scroller').css('left', this.position + 'px');

    };
    this.scrollRight = function() {
        if(this.position===0) {
            return;
        }

        this.position += this.increments;
        $('#chapter-loader-scroller').css('left', this.position + 'px');
        var newActive = this.active.previousElementSibling;
        var active = this.active;
        window.setTimeout(function(){$(active).remove()}, 300);
        this.active = newActive;
        if(this.position===0) {
            $('#sidebar .controls a.prev').css('display', 'none');
        }
    };
    this.loadChapter = function(chapter, title) {
        // create wrapper elements
        var div = document.createElement('div');
        div.className = 'testchapter';
        
        
        // create header w/controls
        var header = document.createElement('header');

        var h1 = document.createElement('h1');

        console.log(chapter);
        h1.innerHTML = title;


        var back = document.createElement('a');
        back.innerHTML = '<div class="purty"></div>';
        back.className = 'back';
        header.appendChild(back);

        header.appendChild(h1);

        $(back).click(function(){
            acc.scrollRight();
        });

        div.appendChild(header);
        

        
        var nav = document.createElement('nav');
        var ul = document.createElement('ul');
        div.appendChild(nav);
        nav.appendChild(ul);


        document.getElementById('chapter-loader-scroller').appendChild(div);
        // populate list
        chapter.forEach(function(element){
            element.isLastChild = true;
            ul.appendChild(createChapterEntry(element));
        });
        this.active = div;
        this.scrollLeft();
    };
}
var acc = new asideChapterContainer();

// $('.testchapter').live('mousewheel', function(ev){
//     console.log(ev);

//     ev.originalEvent.wheelDeltaY;
// });


$('#prev-chapter-page').click(function(e){
    e.preventDefault();
    acc.scrollRight();
    return false;
});



$('#prevpage').click(function(){
    previousPage();
});
$('#nextpage').click(function(){
    nextPage();
});


function formatName(name) {
    name = name.toLowerCase().replace(/ /g,"-"); //TODO: erstatte flere tegn
    return name;
}







// $('#main-wrapper').click(function(){
//     alert('yo!');
// })


// function createBibMeta(cite) {
//     var div = $('#meta-'+cite);
//     var table = document.createElement('table');
//     div.appendChild(table);

//     for(key in cite) {
//         console.log(key);
//     }
// }


// $(function(){
//     $('#sidebar').toggleClass('visible');
// });


